<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<%
	if (Application.getMajorVersion() == 3 && Application.getMinorVersion() == 0)
	{
		%>
		<link rel="stylesheet" type="text/css" href="css/base30.css">
		<%
	}
	%>
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
	
<style>
.ndconc
{
	font-size: 0.85em;
	color: #777777;
}
</style>
	
<script language="JavaScript">
var debug = false;
var HiSense_Limit = 25;
var currentStep = 1;
var rnaQcBioPlates = null;
var rnaQcProtocols = null;
var selectedRnaExtracts = null;
var selectedBioPlate = null;

var bioPlateNameIsValid = false;

var WELL_ALPHA = [ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

function init()
{
	var frm = document.forms['reggie'];

	var rnaExtracts = getRnaExtractsWithoutQc();
	
	var rnaList = frm.rnaExtracts;
	if (rnaExtracts != null && rnaExtracts.length > 0)
	{
		for (var i=0; i < rnaExtracts.length; i++)
		{
			var rna = rnaExtracts[i];
			var name = rna.name;
			if (rna.bioWell)
			{
				name += ' -- ' + rna.bioWell.bioPlate.name + ' (' + WELL_ALPHA[rna.bioWell.row]+(rna.bioWell.column+1)+')';
			}
			var option = new Option(name, rna.id);
			option.rna = rna;
			rnaList.options[rnaList.length] = option;
		}
	}
	else
	{	
		setInputStatus('rna','No RNA available for quality control.', 'invalid')
	}
	Main.show('gonext');
}

function getRnaExtractsWithoutQc()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading RNA extracts...');
		var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=GetRnaExtractsWithoutQc';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.rnaExtracts;
}

var subtypeRna = null;
function selectRna()
{
	var frm = document.forms['reggie'];
	if (frm.rnaExtracts.disabled) return;
	
	if (subtypeRna == null)
	{
		var request = Ajax.getXmlHttpRequest();
		var url = 'Subtype.servlet?ID=<%=ID%>&cmd=GetSubtypeInfo&name=RNA';
		request.open("GET", url, false);	
		request.send(null);

		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		subtypeRna = response.subtype;
	}
	
	var url = getRoot() + 'biomaterials/extracts/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=setRnaCallback';
	url += '&filter:INT:itemSubtype='+subtypeRna.id;
	Main.openPopup(url, 'SelectRNA', 1000, 700);
}
function setRnaCallback(id, name)
{
	var frm = document.forms['reggie'];
	var rnaList = frm.rnaExtracts;
	for (var i = 0; i < rnaList.length; i++)
	{
		if (rnaList[i].value == id)
		{
			rnaList[i].selected = true;
			return;
		}
	}
	
	// Get more information about the selected rna
	var request = Ajax.getXmlHttpRequest();
	var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=GetRnaInfo&rnaId=' + id;		
	request.open("GET", url, false);	
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var rna = response.rna;
	var name = rna.name;
	if (rna.bioWell)
	{
		name += ' -- ' + rna.bioWell.bioPlate.name + ' (' + WELL_ALPHA[rna.bioWell.row]+(rna.bioWell.column+1)+')';
	}

	var option = new Option(name, id, true, true);
	option.rna = rna;
	rnaList[rnaList.length] = option;
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	Main.hide('navigation');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	else if (currentStep == 2)
	{
		gotoStep3();
	}
	Main.show('navigation');
}

function step1IsValid()
{
	var frm = document.forms['reggie'];
	var rnaList = frm.rnaExtracts;
	selectedRnaExtracts = new Array();
	for (var i=0; i < rnaList.length; i++)
	{
		if (rnaList[i].selected)
		{
			selectedRnaExtracts[selectedRnaExtracts.length] = rnaList[i].rna;
		}
	}
	
	if (selectedRnaExtracts.length == 0)
	{
		setInputStatus('rna', 'Not selected', 'invalid');
		return false;
	}
	
	setInputStatus('rna', '', 'valid');

	return true;
}

function gotoStep2()
{
	if (!step1IsValid()) return;
	
	var frm = document.forms['reggie'];
	
	// Disable step1 controls
	frm.rnaExtracts.disabled = true;
	Main.addClass(document.getElementById('btnSelectRna'), 'disabled');
	
	// Load and populate bioplate selection list
	getActiveRnaQcBioPlates();
	for (var i = 0; i < rnaQcBioPlates.length; i++)
	{
		frm.bioPlates[frm.bioPlates.length] = new Option(rnaQcBioPlates[i].name + ' -- ' + rnaQcBioPlates[i].freeWells + ' free wells', rnaQcBioPlates[i].id);		
	}
	frm.bioPlates[frm.bioPlates.length] = new Option('- create new -', 0);

	// Load and populate protcol selection list
	getQualityControlProtocols();
	for (var i = 0; i < rnaQcProtocols.length; i++)
	{
		frm.protocols[frm.protocols.length] = new Option(rnaQcProtocols[i].name, rnaQcProtocols[i].id);		
	}
	if (frm.protocols.length == 0)
	{
		frm.protocols[0] = new Option('- none -', 0);
	}
	
	// Show step 2
	Main.show('bioPlateSection');
	Main.show('gocancel');
	bioPlateOnChange();
	frm.bioPlates.focus();
	currentStep = 2;
}

function getActiveRnaQcBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading RNAQC bioplates...');
		var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=GetActiveRnaQcBioPlates&numFreeWells=' + selectedRnaExtracts.length;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	rnaQcBioPlates = response.plates;
	
}

function getQualityControlProtocols()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading protocols...');
		var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=GetProtocols';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	rnaQcProtocols = response.protcols;
}

// If the 'create new' option is selected we need to display that section
function bioPlateOnChange()
{
	var frm = document.forms['reggie'];
	
	var createNewSelected = frm.bioPlates.selectedIndex == frm.bioPlates.length-1;
	Main.showHide('createNewBioPlateSection', createNewSelected);
	
	if (createNewSelected)
	{
		if (frm.bioPlateName.value == '') bioPlateTypeOnChange();
		frm.bioPlateBarcode.focus();
	}
}

//	We need to get the next auto-generated name for a new CaliperPlate or BAPlate
function bioPlateTypeOnChange()
{
	var frm = document.forms['reggie'];
	
	var request = Ajax.getXmlHttpRequest();
	var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=GetNextAutoGeneratedPlateName&bioPlateType=' + Forms.getCheckedRadio(frm.bioPlateType).value;	
	request.open("GET", url, false);	
	request.send(null);

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	frm.bioPlateName.value = response.nextPlateName;
	bioPlateNameOnChange();
}

// Validate that the new plate name is ok
function bioPlateNameOnChange()
{
	var frm = document.forms['reggie'];
	var bioPlateName = frm.bioPlateName.value;
	bioPlateNameIsValid = false;
	if (bioPlateName == '')
	{
		setInputStatus('bioplatename', 'Missing', 'invalid');
		return;
	}
	
	bioPlateNameIsValid = true;
	
	if (bioPlateName.indexOf('CaliperPlate') != 0 && bioPlateName.indexOf('BAPlate') != 0)
	{
		setInputStatus('bioplatename', 'Should start with <i>CaliperPlate</code> or <i>BAPlate</i>.', 'warning');
		return;
	}

	setInputStatus('bioplatename', '', 'valid');
}



function step2IsValid()
{
	var frm = document.forms['reggie'];
	var bioPlateId = frm.bioPlates[frm.bioPlates.selectedIndex].value;
	if (bioPlateId == 0)
	{
		return bioPlateNameIsValid;
	}

	return true;
}

function gotoStep3()
{
	if (!step2IsValid()) return;
	
	var frm = document.forms['reggie'];
	
	var bioPlateId = frm.bioPlates[frm.bioPlates.selectedIndex].value;
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading information about free wells...');
		var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=GetFreeWellsInfo&bioPlateId='+bioPlateId;
		if (bioPlateId == 0)
		{
			url += '&bioPlateType=' + Forms.getCheckedRadio(frm.bioPlateType).value;
		}
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	selectedBioPlate = response.bioPlate;
	if (selectedBioPlate.id == 0)
	{
		selectedBioPlate.name = frm.bioPlateName.value;
		selectedBioPlate.barcode = frm.bioPlateBarcode.value;
	}
	
	frm.bioPlates.disabled = true;
	frm.protocols.disabled = true;
	frm.bioPlateName.disabled = true;
	frm.bioPlateBarcode.disabled = true;
	frm.bioPlateType[0].disabled = true;
	frm.bioPlateType[1].disabled = true;
	
	var html = '';
	for (var i=0; i < selectedRnaExtracts.length; i++)
	{
		var rna = selectedRnaExtracts[i];
		rna.isValid = false;
		var specimen = null;
		var boxValue = '';
		var rowValue = '';
		var columnValue = '';

		var row = 'row'+i;
		var column = 'column'+i;
		var hiSense = 'hiSense'+i;
		
		var hiSenseChecked = '';
		var ndConc = null;
		if (rna.NDConc)
		{
			ndConc = rna.NDConc;
			if (ndConc < HiSense_Limit)
			{
				hiSenseChecked = 'checked';
			}
		}

		html += i == 0 ? '<tr>' :  '<tr style="border-top: 1px solid #cccccc;">';
		html += '<td class="prompt">'+rna.nextRnaQcName+'</td>';
		html += '</tr>';
		html += '<tr><td class="subprompt">Row</td>'
		html += '<td style="width:600px;"><input style="text-transform:uppercase;" type="text" onkeypress="focusOnEnter(event, \''+column+'\')" name='+row+' value="' + rowValue + '" size="3" maxlength="2" ';
		html += ' onfocus="wellOnFocus('+i+')" onBlur="wellOnChange('+i+')">';
		html += '&nbsp;Column<input type="text" onkeypress="focusOnEnter(event, \'row'+(i+1)+'\')" name='+column+' value="'+ columnValue + '" size="3" maxlength="3" ';
		html += ' onBlur="wellOnChange('+i+')">';
		html += '&nbsp;<span class="link" onclick="suggestWellOnClick('+i+')">Suggest</span>&nbsp;&nbsp;';
		html += '<input type="checkbox" name="'+hiSense+'" id="' + hiSense + '" value="1" ' + hiSenseChecked + '>';
		html += '<label for="'+hiSense+'">HiSense</label>';
		if (ndConc) html += ' <span class="ndconc">(' + ndConc + ' ng/μl)</span>';
		html += '</td>';
		html += '<td class="status" id="well'+i+'.status" rowspan="2"></td>';
		html += '</tr>'
		html += '<tr><td></td>'
		html += '<td class="help" style="width:600px;"><span id="well'+i+'.message" class="message"></span></td>';		
		html += '</tr>';
		
	}
	setInnerHTML('rnaQc', html);
	currentStep = 3;
	Main.show('rnaQcSection');	
	Main.hide('gonext');
	Main.show('gocreate');	
	
	frm['row'+0].focus();
}

function suggestWellOnClick(index)
{
	var frm = document.forms['reggie'];
	if (frm['row'+index].disabled) return;
	
	var bioWells = selectedBioPlate.bioWells;
	
	// Find first unused well not followed by any used well
	var lastUnused = -1;
	for (var i = 0; i < bioWells.length; i++)
	{
		var well = bioWells[i];
		if (well.canAdd && !well.isSuggested && lastUnused == -1)
		{
			lastUnused = i;
		}
		else if (!well.canAdd || well.isSuggested)
		{
			lastUnused = -1;
		}
	}
	
	if (lastUnused >= 0)
	{
		var well = bioWells[lastUnused];
		well.isSuggested = true;
		frm['row'+index].value = WELL_ALPHA[well.row];
		frm['column'+index].value = well.column+1;
		wellOnChange(index);
	}
	
}

function wellOnFocus(index)
{
	var frm = document.forms['reggie'];
	var row = frm['row'+index].value;
	var column = frm['column'+index].value;

	if (row == '' && column == '') suggestWellOnClick(index);
}

function wellOnChange(index)
{
	var frm = document.forms['reggie'];
	var row = frm['row'+index].value;
	var column = frm['column'+index].value;
	
	selectedRnaExtracts[index].isValid = false;
	
	if (row == '' && column == '')
	{
		setInputStatus('well'+index, 'Missing coordinates', 'invalid');
		return;
	}
	
	// Validate row
	if (row == '')
	{
		setInputStatus('well'+index, 'Missing row value', 'invalid');
		return;
	}
	
	var rowC = WELL_ALPHA.indexOf(row.toUpperCase());
	if (rowC < 0 || rowC >= selectedBioPlate.geometry.rows)
	{
		setInputStatus('well'+index, 'Row must be between A-' + WELL_ALPHA[selectedBioPlate.geometry.rows-1], 'invalid');
		return;
	}
	
	// Validate column
	if (column == '')
	{
		setInputStatus('well'+index, 'Missing column value', 'invalid');
		return;
	}
	
	var colC = parseInt(column)-1;
	if (isNaN(colC) || colC < 0 || colC >= selectedBioPlate.geometry.columns)
	{
		setInputStatus('well'+index, 'Column must be between 1-' + selectedBioPlate.geometry.columns, 'invalid');
		return;
	}
	
	// Find the selected well
	var well = getWellByCoordinate(selectedBioPlate, rowC, colC);
	
	// Check that it is not already used
	if (!well.canAdd)
	{
		setInputStatus('well'+index, 'The selected well is already used', 'invalid');
		return;
	}
	
	// Seems to be ok
	setInputStatus('well'+index, ' ', 'valid');
	selectedRnaExtracts[index].isValid = true;
}

//	Get a well from a plate given a coordinate.
function getWellByCoordinate(bioPlate, row, col)
{
	for (var i = 0; i < bioPlate.bioWells.length; i++)
	{
		var w = bioPlate.bioWells[i];
		if (w.row == row && w.column == col)
		{
			return w;
		}
	}
	return null;
}


function step3IsValid()
{
	var frm = document.forms['reggie'];
	setInnerHTML('gonext.message', '');

	// Check that no wells have an error or is used for two 
	var used = new Array();
	for (var i = 0; i < selectedRnaExtracts.length; i++)
	{
		var rna = selectedRnaExtracts[i];
		if (!rna.isValid)
		{
			setInnerHTML('gonext.message', rna.nextRnaQcName + ' has missing or invalid information.');
			frm['row'+i].focus();
			return false;
		}
		
		var row = frm['row'+i].value.toUpperCase();
		var column = frm['column'+i].value;
		var key = row+column;
		if (used[key])
		{
			setInputStatus('well'+i, rna.nextRnaQcName + ' is using the same well as ' + used[key].nextRnaQcName, 'invalid');
			setInnerHTML('gonext.message', 'Found duplicate RNA in the same well');
			frm['row'+i].focus();
			return false;
		}
		used[key] = rna;
	}
	
	return true;
}

function goCreate()
{
	if (!step3IsValid()) return;

	Main.hide('gocancel');
	Main.hide('gocreate');
	Main.hide('goupdate');
	var frm = document.forms['reggie'];
	
	var submitInfo = new Object();
	selectedBioPlate.bioWells = null;
	submitInfo.bioplate = selectedBioPlate;
	
	var protocol = new Object();
	protocol.id = parseInt(frm.protocols[frm.protocols.selectedIndex].value);
	if (protocol.id != 0)
	{
		submitInfo.protocol = protocol;
	}
	
	var rnaQcExtracts = new Array();
	for (var i=0; i < selectedRnaExtracts.length; i++)
	{
		var rnaQc = new Object();
		rnaQc.parentId = parseInt(selectedRnaExtracts[i].id);
		rnaQc.name = selectedRnaExtracts[i].nextRnaQcName;
		rnaQc.row = frm['row'+i].value;
		rnaQc.column = frm['column'+i].value;
		rnaQc.QCHiSense = frm['hiSense'+i].checked ? true : false;
		rnaQcExtracts[rnaQcExtracts.length] = rnaQc;
	}
	submitInfo.rnaQcExtracts = rnaQcExtracts;

	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Creating RNAQC aliquotes on bioplate...');
		var url = 'RnaQc.servlet?ID=<%=ID%>&cmd=PlaceRnaQcAliquots';
		request.open("POST", url, false);
		request.setRequestHeader("Content-Type", "application/json");
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}

	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');
}

</script>


</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="RNA quality control - create aliquots" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 800px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Case name-->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select RNA</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">RNA extracts</td>
				<td class="input" rowspan="2"><select style="width:90%" name="rnaExtracts" id="rnaExtracts" multiple="multiple" size="12" 
					onkeypress='doOnTab(event, goNextAuto)'></select>
					
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button title="Select manually&hellip;" onclick="selectRna()" id="btnSelectRna" />
					</base:buttongroup>
					
				</td>
				<td class="status" id="rna.status" rowspan="2"></td>
				<td class="help" rowspan="2"><span id="rna.message" class="message" style="display: none;"></span>
					The list contain RNA extracts that has not yet been selected for
					quality control (determined by absence of a RNAQC child extract).
					Use the <b>Select manually</b> button for free selection.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div id="bioPlateSection" style="display: none;">
		<p></p>
		<table border="0" cellspacing="0" cellpadding="0" class="stepform">
		<tr>
			<td rowspan="2" class="stepno">2</td>
			<td class="steptitle">Select RNAQC bioplate and protocol</td>
		</tr>
		<tr>
			<td class="stepfields">
				<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr valign="top">
					<td class="prompt">Use existing bioplate</td>
					<td class="input">
						<select style="width:90%" name="bioPlates" id="bioPlates" onchange="bioPlateOnChange()"></select>
					</td>
					<td class="status" id="bioplates.status"></td>
					<td class="help"><span id="bioplates.message" class="message" style="display: none;"></span>
						The list contain RNAQC bioplates without quality score data (determined by absence of 
						QCRunDate annotation) with enough free wells to place the selected RNA extracts.
						Select the <b>create new</b> option to create a new plate.
					</td>
				</tr>
				<tbody id="createNewBioPlateSection" style="display: none;">
					<tr valign="top">
						<td class="prompt">Create new bioplate</td>
						<td class="input">
							<input type="radio" name="bioPlateType" value="CALIPER_RNAQC" id="CALIPER_RNAQC" checked onchange="bioPlateTypeOnChange()"><label for="CALIPER_RNAQC">Caliper</label>
							<input type="radio" name="bioPlateType" value="BA_RNAQC" id="BA_RNAQC" onchange="bioPlateTypeOnChange()"><label for="BA_RNAQC">Bioanalyzer</label>
							
						</td>
						<td class="status"></td>
						<td class="help">Select the type of bioplate to create</td>
					</tr>
					<tr valign="top">
						<td class="subprompt">Name</td>
						<td class="input"><input type="text" class="text required" name="bioPlateName" onblur="bioPlateNameOnChange()"></td>
						<td class="status" id="bioplatename.status"></td>
						<td class="help">
							<span id="bioplatename.message" class="message" style="display: none;"></span>
							<i>CaliperPlateNNNN</i> or <i>BAPlateNNNN</i>. Using a different name 
							pattern may cause other wizards to fail.
						</td>
					</tr>
					<tr valign="top">
						<td class="subprompt">Barcode</td>
						<td class="input"><input type="text" class="text" name="bioPlateBarcode"></td>
						<td class="status" id="bioplatebarcode.status"></td>
						<td class="help">
							The barcode is optional.
						</td>
					</tr>
				</tbody>
				<tr valign="top">
					<td class="prompt">Protocol</td>
					<td class="input">
						<select style="width:90%" name="protocols" id="protocols" onkeypress='doOnTab(event, goNextAuto)'></select>
					</td>
					<td class="status" id="protocols.status"></td>
					<td class="help"><span id="protocols.message" class="message" style="display: none;"></span>
						Select the protocol which is used in the quality control.
					</td>
				</tr>

				</table>
			</td>
		</tr>
		</table>
	</div>
	
	<div id="rnaQcSection" style="display: none;">
		<p></p>
		<table border="0" cellspacing="0" cellpadding="0" class="stepform">
		<tr>
			<td rowspan="2" class="stepno">3</td>
			<td class="steptitle">Enter RNA QC aliquot information</td>		
		</tr>
		<tr>
			<td class="stepfields">
				<table id="rnaQc" style="width: 100%; border-collapse: collapse; border-top: 1px solid transparent;">
				</table>
			</td>
		</tr>
		</table>
		
	</div>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 800px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 800px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" style="display: none;"/></td>
			<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="goupdate" title="Update" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>